#===============================================================================
# Replace the param names with a nice display in table
#===============================================================================
.renameParamNames <- function (param) {

  #Rsq_adjusted, Rsq, Corr_XY,No_points_lambda_z,Lambda_z,Lambda_z_lower,Lambda_z_upper,HL_Lambda_z,Span,Lambda_z_intercept,T0,Tlag,Tmax_Rate,Max_Rate,Mid_Pt_last,Rate_last,Rate_last_pred,AURC_last,AURC_last_D,Vol_UR,Amount_Recovered,PerCent_Recovered,AURC_all,AURC_INF_obs,AURC_PerCentExtrap_obs,AURC_INF_pred,AURC_PerCentExtrap_pred,C0,Tmin,Cmin,Tmax,Cmax,Cmax_D,Tlast,Clast,AUClast,AUClast_D,AUMClast,AUCall,AUCINF_obs,AUCINF_D_obs,AUCINF_pred,AUCINF_D_pred,AUC_PerCentExtrap_obs,AUC_PerCentBack_Ext_obs,AUMCINF_obs,AUMC_PerCentExtrap_obs,Vz_F_obs,Cl_F_obs,Cl_obs,Cl_pred,Vss_obs,Clast_pred,AUC_PerCentExtrap_pred,AUC_PerCentBack_Ext_pred,AUMCINF_pred,AUMC_PerCentExtrap_pred,Vz_F_pred,Cl_F_pred,Vss_pred,Tau,Ctau,Ctrough,AUC_TAU,AUC_TAU_D,AUC_TAU_PerCentExtrap,AUMC_TAU,Vz,Vz_obs,Vz_pred,Vz_F,CLss_F,CLss,Cavg,FluctuationPerCent,FluctuationPerCent_Tau,Accumulation_Index,Swing,Swing_Tau,Dose,N_Samples,MRTlast,MRTINF_obs,MRTINF_pred

  param <- sub(x = param, pattern = "AUC(?=_\\d)", replacement = "as_chunk('AUC'),", perl = TRUE)
  param <- sub(x = param, pattern = "AURC(?=_\\d)", replacement = "as_chunk('AURC'),", perl = TRUE)
  param <- sub(x = param, pattern = "Cavg(?=_\\d)", replacement = "as_chunk('C'),as_sub('avg'),", perl = TRUE)
  param <- sub(x = param, pattern = "_(?=\\d+.*\\d*_(?!D))", replacement = "as_sub('", perl = TRUE)
  param <- sub(x = param, pattern = "(?<=\\d)_(?=\\d)", replacement = "-", perl = TRUE)
  param <- sub(x = param, pattern = "(?<!0)(?<=\\d)$", replacement = "')", perl = TRUE)
  param <- sub(x = param, pattern = "(?<=\\d)_D", replacement = "'),as_chunk('/Dose')", perl = TRUE)

  # replace the _D by /Dose"
  param <- sub(x = param, pattern = "AUCINF_D_obs", replacement = "as_chunk('AUC'),as_sub('0-inf'),as_chunk('/Dose')")
  param <- sub(x = param, pattern = "AUCINF_D_pred", replacement = "as_chunk('AUC'),as_sub('0-inf,pred'),as_chunk('/Dose')")
  param <- sub(x = param, pattern = "Cmax_D", replacement = "as_chunk('C'),as_sub('max'),as_chunk('/Dose')")
  param <- sub(x = param, pattern = "AUClast_D", replacement = "as_chunk('AUC'),as_sub('t'),as_chunk('/Dose')")
  param <- sub(x = param, pattern = "AURC_last_D", replacement = "as_chunk('AURC'),as_sub('t'),as_chunk('/Dose')")
  param <- sub(x = param, pattern = "AUC_TAU_D", replacement = "as_chunk('AUC'),as_sub('tau'),as_chunk('/Dose')")

  # R2
  param <- sub(x = param, pattern = "Flag_Rsq_adjusted", replacement =  "as_chunk('Flag R'),as_sup('2'),as_sub('adj')")
  param <- sub(x = param, pattern = "Rsq_adjusted", replacement =  "as_chunk('R'),as_sup('2'),as_sub('adj')")
  param <- sub(x = param, pattern = "Rsq", replacement =  "as_chunk('R'),as_sup('2')")

  # lamba Z
  param <- sub(x = param, pattern = "AUC_0_24", replacement =  "as_chunk('AUC'),as_sub('24h')")
  param <- sub(x = param, pattern = "AUCINF_obs", replacement =  "as_chunk('AUC'),as_sub('0-inf')")
  param <- sub(x = param, pattern = "AUCINF_pred", replacement =  "as_chunk('AUC'),as_sub('0-inf')")
  param <- sub(x = param, pattern = "Flag_AUC_PerCentExtrap_pred", replacement =  "as_chunk('FLAG AUC'),as_sub('extrap%')")
  param <- sub(x = param, pattern = "Flag_AUC_PerCentExtrap_obs", replacement =  "as_chunk('FLAG AUC'),as_sub('extrap%')")
  param <- sub(x = param, pattern = "AUC_PerCentExtrap_obs", replacement =  "as_chunk('AUC'),as_sub('extrap%')")
  param <- sub(x = param, pattern = "AUC_PerCentExtrap_pred", replacement =  "as_chunk('AUC'),as_sub('extrap%')")
  param <- sub(x = param, pattern = "AUClast", replacement =  "as_chunk('AUC'),as_sub('t')")

  param <- sub(x = param, pattern = "AUMCINF_obs", replacement =  "as_chunk('AUMC'),as_sub('0-inf')")
  param <- sub(x = param, pattern = "AUMCINF_pred", replacement =  "as_chunk('AUMC'),as_sub('0-inf')")
  param <- sub(x = param, pattern = "MRTINF_obs", replacement =  "as_chunk('MRT'),as_sub('0-inf')")
  param <- sub(x = param, pattern = "MRTINF_pred", replacement =  "as_chunk('MRT'),as_sub('0-inf')")
  param <- sub(x = param, pattern = "AUMC_PerCentExtrap_obs", replacement =  "as_chunk('AUMC'),as_sub('extrap%')")
  param <- sub(x = param, pattern = "AUMC_PerCentExtrap_pred", replacement =  "as_chunk('AUMC'),as_sub('extrap%')")
  param <- sub(x = param, pattern = "AUMClast", replacement =  "as_chunk('AUMC'),as_sub('t')")
  param <- sub(x = param, pattern = "MRTlast", replacement =  "as_chunk('MRT'),as_sub('t')")

  param <- sub(x = param, pattern = "Flag_Span", replacement =  "as_chunk('FLAG span')")

  param <- sub(x = param, pattern = "C0", replacement =  "as_chunk('C'),as_sub('0')")
  param <- sub(x = param, pattern = "Cmin", replacement =  "as_chunk('C'),as_sub('min')")
  param <- sub(x = param, pattern = "Cmax", replacement =  "as_chunk('C'),as_sub('max')")
  param <- sub(x = param, pattern = "Clast_pred", replacement =  "as_chunk('C'),as_sub('last')")
  param <- sub(x = param, pattern = "Clast", replacement =  "as_chunk('C'),as_sub('last')")
  param <- sub(x = param, pattern = "Cavg", replacement =  "as_chunk('C'),as_sub('avg')")

  param <- sub(x = param, pattern = "Cl_F_obs", replacement =  "as_chunk('Cl'),as_sub('obs')")
  param <- sub(x = param, pattern = "Vz_F_obs", replacement =  "as_chunk('V'),as_sub('obs')")
  param <- sub(x = param, pattern = "Cl_obs", replacement =  "as_chunk('Cl'),as_sub('obs')")
  param <- sub(x = param, pattern = "Vz_obs", replacement =  "as_chunk('V'),as_sub('obs')")

  param <- sub(x = param, pattern = "Cl_F_pred", replacement =  "as_chunk('Cl'),as_sub('pred')")
  param <- sub(x = param, pattern = "Vz_F_pred", replacement =  "as_chunk('V'),as_sub('pred')")
  param <- sub(x = param, pattern = "Cl_pred", replacement =  "as_chunk('Cl'),as_sub('pred')")
  param <- sub(x = param, pattern = "Vz_pred", replacement =  "as_chunk('V'),as_sub('pred')")

  param <- sub(x = param, pattern = "T0", replacement =  "as_chunk('T'),as_sub('0')")
  param <- sub(x = param, pattern = "Tmin", replacement =  "as_chunk('T'),as_sub('min')")
  param <- sub(x = param, pattern = "Tmax_Rate", replacement =  "as_chunk('T'),as_sub('max')")
  param <- sub(x = param, pattern = "Tmax", replacement =  "as_chunk('T'),as_sub('max')")
  param <- sub(x = param, pattern = "Tlast", replacement =  "as_chunk('T'),as_sub('last')")

  param <- sub(x = param, pattern = "HL_Lambda_z", replacement =  "as_chunk('T'),as_sub('1/2')")

  # \u03bb
  param <- sub(x = param, pattern = "Lambda_z_intercept", replacement =  "as_chunk('lambda'),as_sub('z,inter')")
  param <- sub(x = param, pattern = "Lambda_z_upper", replacement =  "as_chunk('lambda'),as_sub('z,upper')")
  param <- sub(x = param, pattern = "Lambda_z_lower", replacement =  "as_chunk('lambda'),as_sub('z,lower')")
  param <- sub(x = param, pattern = "Lambda_z", replacement =  "as_chunk('lambda'),as_sub('z')")

  param <- sub(x = param, pattern = "N_Samples", replacement =  "as_chunk('N'),as_sub('samples')")
  param <- sub(x = param, pattern = "No_points_lambda_z", replacement =  "as_chunk('N'),as_sub('points,lambda_z')")

  if(length(grep(x = param, pattern = "as_chunk"))==0){
    param = paste0("as_chunk('",param,"')")
  }
  return (param)
}

#===========================================================================================
# Replace the param names with a nice display in plots
#===========================================================================================
.renameParamNamesPlots <- function(param){

  # replace the _D by /Dose"
  param <- sub(x = param, pattern = "_D", replacement =  "/Dose")

  # R2
  param <- sub(x = param, pattern = "Rsq_adjusted", replacement =  'R^{"2"}["adj"]')
  param <- sub(x = param, pattern = "Rsq", replacement =  'R^{"2"}')

  # lamba Z
  param <- sub(x = param, pattern = "AUC_0_24", replacement =  'AUC["24h"]')
  param <- sub(x = param, pattern = "AUCINF_obs", replacement =  'AUC["0-inf"]')
  param <- sub(x = param, pattern = "AUC_PerCentExtrap_obs", replacement =  'AUC["Extrap, %"]')
  param <- sub(x = param, pattern = "AUClast", replacement =  'AUC["t"]')

  param <- sub(x = param, pattern = "C0", replacement =  'C["0"]')
  param <- sub(x = param, pattern = "Cmin", replacement =  'C["min"]')
  param <- sub(x = param, pattern = "Cmax", replacement =  'C["max"]')
  param <- sub(x = param, pattern = "Clast", replacement =  'C["last"]')
  param <- sub(x = param, pattern = "Cavg_0_24", replacement =  'C["avg 24h"]')
  param <- sub(x = param, pattern = "Cavg", replacement =  'C["avg"]')

  param <- sub(x = param, pattern = "Cl_F_obs", replacement = 'Cl["obs"]')
  param <- sub(x = param, pattern = "Vz_F_obs", replacement =  'V["obs"]')
  param <- sub(x = param, pattern = "Cl_obs", replacement =  'Cl["obs"]')
  param <- sub(x = param, pattern = "Vz_obs", replacement =  'V["obs"]')

  param <- sub(x = param, pattern = "T0", replacement =  'T["0"]')
  param <- sub(x = param, pattern = "Tmin", replacement =  'T["min"]')
  param <- sub(x = param, pattern = "Tmax", replacement =  'T["max"]')
  param <- sub(x = param, pattern = "Tlast", replacement =  'T["last"]')

  param <- sub(x = param, pattern = "HL_Lambda_z", replacement =  'T["1/2"]')

  # \u03bb
  param <- sub(x = param, pattern = "Lambda_z_intercept", replacement =  'lambda["z, intercept"]')
  param <- sub(x = param, pattern = "Lambda_z", replacement =  'lambda["z"]')

  return (param)
}

#===========================================================================================
# Replace the parameters in the table
#===========================================================================================
.replaceParamNamesTable <- function(x, paramList, line=NULL, col = NULL){

  if (!is.null(line)) {
    iLine  = line
  } else {
    iLine = 1
  }

  if (!is.null(col)) {
    iCol = col
  } else {
    iCol = 1
  }
  for (index in 1:length(paramList)) {
    # j = 1 as it is the Variable
    x <- compose(x , i = index+(iLine-1), j = iCol, eval(parse(text=paste0("as_paragraph(", .renameParamNames(param = paramList[index]),")"))))
  }
  return(x)
}

#===========================================================================================
# Replace the parameters in the headers
#===========================================================================================
.replaceParamNamesHeader <- function(x, paramList, line=NULL, col = NULL){

  if(!is.null(line)){
    iLine  = line
  }else{
    iLine = 1
  }

  if(!is.null(col)){
    iCol = col
  }else{
    iCol = 1+ sum(.lixoftCall("getData")$headerTypes=="occ")
  }

  for(index in 1:length(paramList)){
    # j = 1 as it is the Variable
    x <- compose(x, part="header", i = iLine, j = index+iCol, eval(parse(text=paste0("as_paragraph(", .renameParamNames(param = paramList[index]),")"))))
  }
  return(x)
}

#===========================================================================================
# Rename the units
#===========================================================================================
.renameUnits <- function(param){
  param <- sub(x = param, pattern = ".mL[:^:]-1", replacement =  "/mL")
  param <- sub(x = param, pattern = "mL[:^:]-1", replacement =  "/mL")
  param <- sub(x = param, pattern = ".L[:^:]-1", replacement =  "/L")
  param <- sub(x = param, pattern = "L[:^:]-1", replacement =  "/L")

  param <- sub(x = param, pattern = ".day[:^:]-1", replacement =  "/day")
  param <- sub(x = param, pattern = "day[:^:]-1", replacement =  "/day")
  param <- sub(x = param, pattern = ".h[:^:]-1", replacement =  "/h")
  param <- sub(x = param, pattern = "h[:^:]-1", replacement =  "/h")
  param <- sub(x = param, pattern = ".min[:^:]-1", replacement =  "/min")
  param <- sub(x = param, pattern = "min[:^:]-1", replacement =  "/min")
  param <- sub(x = param, pattern = ".s[:^:]-1", replacement =  "/s")
  param <- sub(x = param, pattern = "s[:^:]-1", replacement =  "/s")

  param <- sub(x = param, pattern = "[:.:]", replacement =  "*")
  if(substring(param, 1, 1)=='/'){
    param <- paste0("1",param)
  }

  return(param)
}

#===========================================================================================
# Replace the units with a nice display in table
#===========================================================================================
.replaceUnitsTable <- function(x, paramList, line = NULL, col = NULL){

  if (!is.null(line)) {
    iLine  = line
  } else {
    iLine = 1
  }

  if (!is.null(col)) {
    iCol = col
  } else {
    iCol = 2
  }
  for (index in 1:length(paramList)) {
    # j = 2 as it is the Units
    x <- compose(x, i = index+(iLine-1), j = iCol, eval(parse(text=paste0("as_paragraph(as_chunk('", .renameUnits(paramList[index]),"'))"))))
  }
  return(x)
}

#===========================================================================================
# Replace the units with a nice display in table header
#===========================================================================================
.replaceUnitsHeader <- function (x, paramList, line=NULL, col = NULL) {

  if (!is.null(line)) iLine = line else iLine = 2

  if (!is.null(col)) {
    iCol = col
  } else {
    iCol = 1 + sum(.lixoftCall("getData")$headerTypes == "occ")
  }

  for (index in 1:length(paramList)) {
    if (nchar(paramList[index]) > 0) {
      x <- compose(x,
                   part = "header",
                   i = iLine,
                   j = index + iCol,
                   eval(
                     parse(
                       text = paste0("as_paragraph(as_chunk('('),as_chunk('",
                                     .renameUnits(param = paramList[index]),
                                     "'),as_chunk(')'))")
                     )
                   ))
    }
  }
  return(x)
}

#===========================================================================================
# Rename the stats
#===========================================================================================
.renameStat <- function (stat) {
  renameStat <- stat
  if (length(stat) > 0) {
    for (indexStat in 1:length(stat)) {
      valStat = tolower(stat[indexStat])
      if (valStat == "geomean") {
        renameStat[indexStat] <- "Geo. mean"
      } else if (valStat=="geosd") {
        renameStat[indexStat] <- "Geo. Sd"
      } else if (valStat=="geocv") {
        renameStat[indexStat] <- "Geo. CV"
      } else if(valStat=="geocv%") {
        renameStat[indexStat] <- "Geo. CV%"
      } else if (valStat == "hmean") {
        renameStat[indexStat] <- "Harm. mean"
      }
    }
  }
  return(renameStat)
}
