################################################################################
# Display settings in Table
################################################################################
.getSmallBorder <-function(wd = 1){
  return(fp_border(color="gray", width = wd))
}
.getThickBorder <-function(wd = 2){
  return(fp_border(color="black", width = wd))
}

.applySettingsTable <- function(flxTable){
  return(flxTable %>%theme_vanilla() %>% align(align="center") %>% padding(padding = 1, part = "all" ) %>%
           align(part = "header", align="center") %>% font(part = "all", fontname = "Calibri"))
}

################################################################################
# Colors in plot
################################################################################
.colorTemplate <-function(nb){
  palette <- c("#00463E", "#F58800", "#54A0E0", "#00B49F", "#D2AF8C", "#2355A2","#E36DA6", "#A21E55", "#71CD4A", "#FFDA00", "#FF0000", "#A9A9A9")
  #palette <- c("blue", "red", "orange", "yellow", "green", "cyan","black")
  return(palette[1:nb])
}

################################################################################
# Display settings in Plots
################################################################################
ggPlotTheme <- function(){
  return(theme(legend.title = element_text(size = 8), legend.text = element_text(size = 8),
               #strip.background = element_rect(fill="white"),
               panel.background = element_blank(),
               panel.border = element_rect(colour = "black", fill=NA), axis.line = element_line(colour = "black"),
               legend.key = element_rect(colour = "transparent", fill = "transparent"),
               legend.justification=c(1,1), legend.position=c(.98,.98),
               legend.background=element_rect(fill = alpha("white", .75)))
  )
}

