% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mlxReportTables.R
\name{getBETable}
\alias{getBETable}
\title{Bioequivalence summary table}
\usage{
getBETable(
  renameFormulations = NULL,
  doseNormalizationUnit = NULL,
  test = NULL
)
}
\arguments{
\item{renameFormulations}{(\emph{vector}) Displayed names of different
formulations.}

\item{doseNormalizationUnit}{(\emph{string}) A string containing dose
normalization unit, if dosing is normalized.}

\item{test}{(\emph{string}) In case of multiple test formulations, test
formulation for which bioequivalence table will be returned.}
}
\value{
A Flextable object.
}
\description{
\code{getBETable} returns a table containing bioequivalence results as a
Flextable object.
}
\examples{
\dontrun{
library(lixoftConnectors)

initializeLixoftConnectors("pkanalix")
demoPath <- getDemoPath()
loadProject(paste0(demoPath, "/3.bioequivalence/project_crossover_bioequivalence.pkx"))
setNCASettings(
  partialAucTime = list(T, c(0, 24)),
  computedNCAParameters = c("AUCINF_obs", "Cmax", "Tmax", "Tlast")
)
runNCAEstimation()
runBioequivalenceEstimation()

BETABLE <- getBETable(renameFormulations = c("1" = "Reference", "2" = "Test"))
BETABLE
}

}
