% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mlxReportPlots.R
\name{getPLOT_byINDIV}
\alias{getPLOT_byINDIV}
\title{Get plot by indiv/using individual fits as ggplot2 object}
\usage{
getPLOT_byINDIV(
  xLab = "Time",
  yLab = "Plasma concentration",
  bLog = F,
  lambda_z = F,
  splitCat = NULL,
  renameSplitCat = NULL,
  filterSplitCat = NULL,
  colorCat = NULL,
  filterCat = NULL,
  filterMod = NULL
)
}
\arguments{
\item{xLab}{(\emph{string}) x-axis label.}

\item{yLab}{(\emph{string}) y-axis label.}

\item{bLog}{(\emph{bool} or \emph{"both"}) y-axis in log scale or both axes in log scale.}

\item{lambda_z}{(\emph{bool}) Show lambda_z.}

\item{splitCat}{(\emph{string}) Categorical covariate to split plots by.}

\item{renameSplitCat}{(\emph{vector}) Display names of categories.}

\item{filterSplitCat}{(\emph{vector}) Categories to filter.}

\item{colorCat}{(\emph{string}) Covariate to color by.}

\item{filterCat}{(\emph{string}) Category to filter by.}

\item{filterMod}{(\emph{string}) Category to filter by.}
}
\value{
a ggplot2 object
}
\description{
Get plot by indiv/using individual fits as ggplot2 object
}
\examples{
\dontrun{
library(lixoftConnectors)

initializeLixoftConnectors("pkanalix")
demoPath <- getDemoPath()
loadProject(paste0(demoPath, "/3.bioequivalence/project_crossover_bioequivalence.pkx"))
setNCASettings(
  partialAucTime = list(T, c(0, 24)),
  computedNCAParameters = c("AUCINF_obs", "Cmax", "Tmax", "Tlast")
)
runNCAEstimation()

indivObs <- getPLOT_byINDIV(
  splitCat = "FORM",
  renameSplitCat = c("ref" = "Reference", "test" = "Test")
)
indivObs
}

}
