test_that("basic censoring works", {

  result <- formatData(dataFilename = "censoring/Censoring.xlsx",
                         idHeader = "ID", timeHeader = "TIME", obsHeader = "Y",
                         doseAmount = 1,
                         censTag = "BLQ", lloq = 0.06, export = F)

  expected <- .readDataset("censoring/Censoring_result.xlsx")
  expected[] <- lapply(expected, as.character)
  expect_equal(result, expected)
})

test_that("censoring with dose amount in data works", {

  result <- formatData(dataFilename = "censoring/CensoringDose.xlsx",
                         idHeader = "ID", timeHeader = "TIME", obsHeader = "Y",
                         doseHeader = "AMT",
                         censTag = "BLQ", lloq = 0.06, export = F)

  expected <- .readDataset("censoring/CensoringDose_result.xlsx")
  expected[] <- lapply(expected, as.character)
  expect_equal(result, expected)
})

test_that("censoring with different tags in data works", {

  result <- formatData(dataFilename = "censoring/CensoringDiffTags.xlsx",
                         idHeader = "ID", timeHeader = "TIME", obsHeader = "Y",
                         doseAmount = 1,
                         censTag = c("BLQ", "BLOQ"), lloq = 0.06, export = F)

  expected <- .readDataset("censoring/CensoringDiffTags_result.xlsx")
  expected[] <- lapply(expected, as.character)
  expect_equal(result, expected)
})
