library(lixoftConnectors)
initializeLixoftConnectors("pkanalix")
op <- options()
op$lixoft_notificationOptions$warnings <- 1
op$lixoft_notificationOptions$info <- 1

metrics <- c("Rsq", "Rsq_adjusted", "Corr_XY", "No_points_lambda_z", "Lambda_z",
             "Lambda_z_lower", "Lambda_z_upper", "HL_Lambda_z", "Span",
             "Lambda_z_intercept", "T0", "Tlag", "Tmax_Rate", "Max_Rate",
             "Mid_Pt_last", "Rate_last", "Rate_last_pred", "AURC_last",
             "AURC_last_D", "Vol_UR", "Amount_Recovered", "PerCent_Recovered",
             "AURC_all", "AURC_INF_obs", "AURC_PerCentExtrap_obs",
             "AURC_INF_pred", "AURC_PerCentExtrap_pred", "C0", "Tmin", "Cmin",
             "Tmax", "Cmax", "Cmax_D", "Tlast", "Clast", "AUClast", "AUClast_D",
             "AUMClast", "AUCall", "AUCINF_obs", "AUCINF_D_obs", "AUCINF_pred",
             "AUCINF_D_pred", "AUC_PerCentExtrap_obs", "AUC_PerCentBack_Ext_obs",
             "AUMCINF_obs", "AUMC_PerCentExtrap_obs", "Vz_F_obs", "Cl_F_obs",
             "Cl_obs", "Cl_pred", "Vss_obs", "Clast_pred", "AUC_PerCentExtrap_pred",
             "AUC_PerCentBack_Ext_pred", "AUMCINF_pred", "AUMC_PerCentExtrap_pred",
             "Vz_F_pred", "Cl_F_pred", "Vss_pred", "Tau", "Ctau", "Ctrough",
             "AUC_TAU", "AUC_TAU_D", "AUC_TAU_PerCentExtrap", "AUMC_TAU",
             "Vz", "Vz_obs", "Vz_pred", "Vz_F", "CLss_F", "CLss", "Cavg",
             "FluctuationPerCent", "FluctuationPerCent_Tau", "Accumulation_Index",
             "Swing", "Swing_Tau", "Dose", "N_Samples", "MRTlast", "MRTINF_obs",
             "MRTINF_pred", "Cavg_Int", "AURC_Int", "AURC_Int_D", "AUC_Int",
             "AUC_Int_D")

demoPath <- getDemoPath()

test_that("the job is finished with all of the parameters", {
  skip('skip')
  demoList <- c("/1.basic_examples/project_extravascular.pkx",
                "/1.basic_examples/project_ivbolus.pkx",
                "/1.basic_examples/project_ivinfusion.pkx",
                "/1.basic_examples/project_urine.pkx",
                "/1.basic_examples/project_steadystate.pkx",
                "/1.basic_examples/project_steadystate_infusion.pkx")

  for (demo in demoList) {
    loadProject(paste0(demoPath, demo))
    setNCASettings(computedNCAParameters = metrics,
                   partialAucTime = list(T, c(1.1, 23.5), c(0, 5)))
    runNCAEstimation()
    getNCASummaryTable()
  }
  expect_equal(2 * 2, 4)
})
